#!/usr/bin/python
"""
runbatchA.py -- Script for running a batch
scripts/runbatchA.py
Last revision: 9/18/13 (georgec)
"""

# Function to display and then, if the commands are turned on, execute the 
# Linux command passed in.
def dosyscmd(sys_str):
    print sys_str
    if (do_commands):
        os.system(sys_str)
        
# Set whether the commands are actually done (as opposed to just displayed).  Used for testing purposes.
do_commands = True

# Set whether we run the STDP only tests.
do_STDPonlies = True
do_RLs = False

# Import packages needed for commands.
import os, sys

# Set up the basic sim call to run without showing the results and with saving
# the data.
basecall_str = 'ipython scripts/stdprltestnet.py noshow t dosave t'
#basecall_str = 'ipython scripts/stdptestnet.py noshow t dosave t'

if do_STDPonlies:
    # Loop over whether prx is excitatory or not...
    for prxexc in ['t', 'f']:
        # Loop over whether we are doing LTP training (vs. LTD)...
        for LTPtrain in ['t', 'f']:
            # Loop over post-synaptic unit type...
            for poxtype in ['IntFire1Unit', 'INTF6Unit', 'SPICellUnit', 'IzhiUnit']:
                # Loop over pre-synaptic unit type...
                for prxtype in ['IntFire1Unit', 'INTF6Unit', 'SPICellUnit', 'IzhiUnit']:    
                    sys_str = '%s prxexcitatory %s trainLTP %s prxunittype %s poxunittype %s' % \
                        (basecall_str, prxexc, LTPtrain, prxtype, poxtype)                  
                    dosyscmd(sys_str)
                    
if do_RLs:                
    # Loop over whether prx is excitatory or not...
    for prxexc in ['t', 'f']:
        # Loop over whether we are doing LTP training (vs. LTD)...
        for LTPtrain in ['t', 'f']:
            # Loop over post-synaptic unit type...
            for poxtype in ['IntFire1Unit', 'INTF6Unit', 'SPICellUnit', 'IzhiUnit']:
                # Loop over pre-synaptic unit type...
                for prxtype in ['IntFire1Unit', 'INTF6Unit', 'SPICellUnit', 'IzhiUnit']:
                    if poxtype in ['INTF6Unit', 'IzhiUnit']:
                        sys_str = '%s RLtest t prxexcitatory %s trainLTP %s prxunittype %s poxunittype %s rewardamp 30.0 punishamp 30.0' % \
                            (basecall_str, prxexc, LTPtrain, prxtype, poxtype)                          
                    else:
                        sys_str = '%s RLtest t prxexcitatory %s trainLTP %s prxunittype %s poxunittype %s' % \
                            (basecall_str, prxexc, LTPtrain, prxtype, poxtype)  
                    dosyscmd(sys_str)
